#undef __FUNC__
#define __FUNC__ "DirectPCApply"
static int DirectPCApply(void *ptr,Vec in, Vec out)
{
  Mat cof = ((DirectPC)ptr)->cof;
  Mat xpl = ((DirectPC)ptr)->xpl;
  int max_it = ((DirectPC)ptr)->it;
  Vec res = ((DirectPC)ptr)->res, dif = ((DirectPC)ptr)->dif;
  int it,ierr; Scalar mone = -1.0;

  /* for it==0, start with a zero guess */
  ierr = MatMult(xpl,in,out); CHKERRQ(ierr);

  /* now the higher iterations */
  for (it=1; it<max_it; it++) {
    ierr = MatMult(cof,out,res); CHKERRQ(ierr);
    ierr = VecAXPY(&mone,in,res); CHKERRQ(ierr);
    ierr = MatMult(xpl,res,dif); CHKERRQ(ierr);
    ierr = VecAXPY(&mone,dif,out); CHKERRQ(ierr);
  }

  return 0;
}

