/* I hope these routines are never used. */
#undef __FUNC__
#define __FUNC__ "NewIndexStash"
int NewIndexStash(IndStash *result_stash)
{
  IndStash stash;

  stash = (IndStash) PetscMalloc( sizeof(struct _IndStash) ); CHKPTRQ(stash);
  stash->nmax = CHUNCKSIZE;
  stash->n    = 0;
  stash->array = (int *) PetscMalloc( stash->nmax*sizeof(int) );
  CHKPTRQ(stash->array);
  {
    int *loc;
    loc = (int *) PetscMalloc( sizeof(int) ); CHKPTRQ(loc);
    *loc = 0;
    stash->private = (PetscObject) loc;
  }
  *result_stash = stash;
  return 0;
}

#undef __FUNC__
#define __FUNC__ "ZeroIndexStash"
int ZeroIndexStash(IndStash stash)
{
  stash->n = 0; stash->array[0] = 0;
  return 0;
}

#undef __FUNC__
#define __FUNC__ "DestroyIndexStash"
int DestroyIndexStash(IndStash stash)
{
  if (stash->array) PetscFree(stash->array); 
  return 0;
}

#undef __FUNC__
#define __FUNC__ "StashIndex"
int StashIndex(IndStash stash, int n, int *idxn)
{
  int    i,row;
  int *n_array;

  for ( i=0; i<n; i++ ) {
    row = idxn[i];
    if ( stash->n == stash->nmax ) {
      /* allocate a larger stash */
      n_array = (int *) PetscMalloc
	( (stash->nmax + CHUNCKSIZE)*(sizeof(int)));
      CHKPTRQ(n_array);
      PetscMemcpy(n_array,stash->array,stash->nmax*sizeof(int));
      if (stash->array) PetscFree(stash->array);
      stash->array = n_array;
      stash->nmax += CHUNCKSIZE;
    }
    stash->array[stash->n++]   = idxn[i];
  }
  return 0;
}

#undef __FUNC__
#define __FUNC__ "Unstash"
int Unstash(IndStash stash, int n)
{
  if (stash->n>n)
    stash->n=stash->n-n;
  else
    stash->n=0;

  return 0;
}

#undef __FUNC__
#define __FUNC__ "StashIndexFind"
int StashIndexFind(int *loc,int item,IndStash stash)
{
/*  Locator *locr = (Locator *) (stash->private);*/
  int *locr = (int *) stash->private;
  int i,locn;

  *loc = 0;
  for (i=0; i<stash->n; i++) {
    locn = *locr /*locr->ptr*/ +i; if (locn >= stash->n) locn = 0;
    if (stash->array[locn]==item) {
      *loc = *locr /*locr->ptr*/ = locn; 
      return 0;
    }
  }
  /*printf("Looking for item %d in stash",item);
    for (i=0; i<stash->n; i++) printf(" %d",stash->array[i]);
    printf("\n");
    SETERRQ(1,0,"Could not find index in stash");*/
  return 1;
}

